#{.compile: "resources.c".}
import gtk3, gio, glib, gobject, sup

template example_app_type*(): expr = example_app_get_type()

#template example_app_type* = example_app_get_type()

#template example_app*(obj: expr): expr = G_TYPE_CHECK_INSTANCE_CAST(obj, EXAMPLE_APP_TYPE, ExampleApp)


template example_app*(obj: expr): expr = 
  (g_type_check_instance_cast(obj, example_app_get_type(), ExampleAppObj))


#proc example_app_get_type*(): GType


type 
  ExampleAppObj* = object of gtk3.ApplicationObj
  ExampleApp* = ptr ExampleAppObj

  ExampleAppClassObj* = object of gtk3.ApplicationClassObj
  ExampleAppClass* = ptr ExampleAppClassObj

  ExampleAppPrivate* = object


import exampleappwin, exampleappprefs

#define G_DEFINE_TYPE(TN, t_n, T_P)			    G_DEFINE_TYPE_EXTENDED (TN, t_n, T_P, 0, {})
template g_define_type(TN, t_n, T_P): expr =
  g_define_type_extended (sup.stringify(TN), t_n, T_P, $0, "")


g_define_type(ExampleApp, "example_app", "application_get_type()")

proc example_app_init(self: ExampleApp) = 
  discard 

proc preferences_activated*(action: gio.GSimpleAction; parameter: glib.GVariant; 
                            app: gpointer) {.cdecl.} = 
  var prefs: ExampleAppPrefs
  var win: gtk3.Window
  win = gtk_application_get_active_window(application(app))
  prefs = example_app_prefs_new(example_app_window(win))
  gtk_window_present(window(prefs))

proc quit_activated*(action: gio.GSimpleAction; parameter: glib.GVariant; 
                     app: gpointer) = 
  g_application_quit(g_application(app))

#var app_entries*: gio.GActionEntry = [["preferences", preferences_activated, 
#                                       nil, nil, nil], 
#                                      ["quit", quit_activated, nil, nil, nil]]


var app_entries*: array[1, gio.GActionEntryObj] = [gio.GActionEntryObj(name: "preferences", activate: preferences_activated, 
                                       parameter_type: nil, state: nil, change_state: nil)]#, 
                                      #addr("quit", quit_activated, nil, nil, nil)]



proc example_app_startup*(app: gio.GApplication) {.cdecl.} = 
  var builder: gtk3.Builder
  var app_menu: gio.GMenuModel
  var quit_accels: array[2, cstring] = [cstring "<Ctrl>Q", nil]
  g_application_class(example_app_parent_class).startup(app)
  add_action_entries(gio.g_action_map(app), addr app_entries[0], 
                                  1, (gpointer) app)
  set_accels_for_action(application(app), "app.quit", 
                                        cast[cstringArray](addr quit_accels))
  #builder = gtk_builder_new_from_resource ("/org/gtk/exampleapp/app-menu.ui");
  builder = gtk_builder_new_from_file("app-menu.ui")
  app_menu = G_MENU_MODEL(gtk_builder_get_object(builder, "appmenu"))
  gtk_application_set_app_menu(GTK_APPLICATION(app), app_menu)
  g_object_unref(builder)

proc example_app_activate*(app: gio.GApplication) {.cdecl.} = 
  var win: ExampleAppWindow
  win = example_app_window_new(example_app(app))
  gtk_window_present(GTK_WINDOW(win))

#proc example_app_open*(app: gio.GApplication; files: varargs[gio.GFile]; 
proc example_app_open*(app: gio.GApplication; files: gio.GFileArray; 
                       n_files: gint; hint: cstring) {.cdecl.} = 
  var windows: glib.GList
  var win: ExampleAppWindow
  var i: cint
  windows = gtk_application_get_windows(GTK_APPLICATION(app))
  if windows != nil: win = example_app_window(windows.data)
  else: win = example_app_window_new(EXAMPLE_APP(app))
  i = 0
  echo n_files
  while i < n_files: 
    #echo "xxx", files == nil
    #echo get_parse_name(files)
    example_app_window_open(win, files[i])
    echo "zzzzzzzzzzzzzzzzzzzzzzzzzz"
    inc(i)
  gtk_window_present(GTK_WINDOW(win))

proc example_app_class_init(klass: ExampleAppClass) = 
  g_application_class(klass).startup = example_app_startup
  g_application_class(klass).activate = example_app_activate
  g_application_class(klass).open = example_app_open

proc example_app_new*(): ExampleApp = 
  cast[ ExampleApp](g_object_new(example_app_type, "application-id", "org.gtk.exampleapp", 
                      "flags", gio.GApplicationFlags.HANDLES_OPEN, nil))
